# Installation

* Prefered option: composer require drupal/jsnlog.
* Manually: Place the module in the modules folder.
  * Download JSNLog library from [JSNLog](http://js.jsnlog.com) and place the folder under webroot/libraries named jsnlog.
  * (Optional - for better output) Download WhichBrowser library from [github](https://github.com/WhichBrowser/Parser-PHP) and place the folder under webroot/libraries named whichbrowser.
* Activate and visit settings page.

# Options

* Enable or disable it.
* Choose logging type: if ajax, console or both.
* Choose library type.
* Debug level to save into watchdog.
* User agent filter to log only specific browsers.
* Include or exclude roles and or pages. 

# Usage

If an javascript error occurres. The event will trigger an ajax callback and the error will be listed in watchdog.

# Custom error triggers

For your custom javascript you may want to use some other notifications from the JSNLog library.

``` javascript
JL().warn("warn message");
JL().info("info message");
JL().fatal("fatal message");
```

Depending on your debug level you configured. These messages will be tracked as well.

# Error mapping from JSNLog to watchdog

---------------------<br>
| JSNLog | Watchdog |<br>
---------------------<br>
| < 2000 | log      |<br>
| < 3000 | debug    |<br>
| < 4000 | info     |<br>
| < 5000 | warning  |<br>
| > 4999 | error    |<br>
---------------------<br>

See: [NumericSeverities](http://js.jsnlog.com/Documentation/HowTo/NumericSeverities)

# Further Information

* http://js.jsnlog.com/Documentation/JSNLogJs
* TODO: Blogpost :)

# Run Tests

```
chromedriver --port=4444
php core/scripts/run-tests.sh --module jsnlog --url [shema]://[domain] --verbose --color --suppress-deprecations
```
